<?php

class Block extends DataObject{

	public static $db = array(
		"Title" 			=> "Varchar",
		"ShowTitle" 	=> "Boolean",
		"Content" 		=> "HTMLText",
		"LinkedTitle" => "Boolean",
		'Position' 		=> 'Varchar',
		'CssClass' 		=> 'Varchar',
		"Sort" 				=> "Int",
		"Active" 			=> "Boolean"
	);
	
	static $has_one = array (
		'Page' => 'Page'
	);
	
	static $summary_fields = array(
		'Title' 		=> 'Title',
		'ClassName'	=> 'ClassName',
		'Position'	=> 'Position',
		'CssClass'	=> 'CssClass',
		'Sort'			=> 'Sort'
	);
	
	static $searchable_fields = array(
		'Title',
		'ClassName' => 'ClassName'
	);
	
	static $default_sort = 'Sort ASC';
	
	static $defaults = array(
		"ShowTitle" => 1,
		"Active" => 1
	);
	
	function getCMSFields() {
		$fields = parent::getCMSFields();
		
		$fields->addFieldToTab("Root.Main",
			new DropdownField(
				"BlockType", 
				$this->fieldLabel('BlockType'), 
				$this->getClassDropdown(), $this->ClassName
			), 'Title'
		);
		
		
		
		
		$fields->addFieldToTab('Root.Main', new HtmlEditorField('Content'), 'LinkedTitle'); 
		
		$fields->addFieldToTab("Root.Main",
			new DropdownField(
				'Position',
				'Position', 
				Dataobject::get("Position")->toDropdownMap("Title", "Title"),
				'','',''
			)
		);
		
		$fields->addFieldToTab("Root.Main",
			new DropdownField(
				'CssClass',
				'CssClass', 
				Dataobject::get("CssClass")->toDropdownMap("Title", "Title"),
				'','',''
			)
		);
		return $fields;
	}
	
	function onBeforeWrite() {
		if(!$this->Sort && $this->Position) {
			$this->Sort = DB::query(
				"SELECT MAX(Sort) + 1 FROM Block WHERE Position = '$this->Position'")->value();
		}
		/*if(isset($_REQUEST['BlockType'])){
			$this->ClassName = $_REQUEST['BlockType'];
		}*/
		parent::onBeforeWrite ();
	}

	protected function getClassDropdown() {
		return ClassInfo::subclassesFor('Block');
	}


}